import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Component } from 'react';
import Chevronright from '@s-ui/react-icons/lib/Chevronright';
import FormCheckbox from '@s-ui/react-form-checkbox';
import cx from 'classnames';

var CardSubscription = /*#__PURE__*/function (_Component) {
  _inheritsLoose(CardSubscription, _Component);

  function CardSubscription() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      termsOfUseAccepted: false,
      showErrorMessage: false
    };
    _this.input = null;

    _this._handleCheckboxChange = function () {
      var termsOfUseAccepted = _this.state.termsOfUseAccepted;

      _this.setState({
        termsOfUseAccepted: !termsOfUseAccepted,
        showErrorMessage: false
      });
    };

    _this._getCheckboxError = function () {
      return _this.state.showErrorMessage && _this.props.checkboxErrorMessage ? _this.props.checkboxErrorMessage : null;
    };

    _this._handleSubmit = function (event) {
      var onSubmit = _this.props.onSubmit;
      var termsOfUseAccepted = _this.state.termsOfUseAccepted;
      event.preventDefault();

      _this.setState({
        showErrorMessage: !termsOfUseAccepted
      });

      termsOfUseAccepted && onSubmit(_this.input.value);
    };

    _this._printCardContent = function (_ref) {
      var termsOfUseAccepted = _ref.termsOfUseAccepted;
      var _this$props = _this.props,
          placeholder = _this$props.placeholder,
          iconButton = _this$props.iconButton,
          responseError = _this$props.responseError,
          checkboxName = _this$props.checkboxName,
          checkboxLabel = _this$props.checkboxLabel,
          checkboxIcons = _this$props.checkboxIcons;
      var IconAngle = iconButton || Chevronright;
      var inputClassName = cx('sui-CardSubscription-input', {
        'has-error': !!responseError
      });
      return /*#__PURE__*/_jsxs("form", {
        onSubmit: _this._handleSubmit,
        className: "sui-CardSubscription-form",
        children: [/*#__PURE__*/_jsxs("div", {
          className: "sui-CardSubscription-formField",
          children: [/*#__PURE__*/_jsx("input", {
            className: inputClassName,
            placeholder: placeholder,
            ref: function ref(node) {
              _this.input = node;
            }
          }), /*#__PURE__*/_jsx("button", {
            type: "submit",
            className: "sui-CardSubscription-button",
            children: /*#__PURE__*/_jsx(IconAngle, {
              svgClass: "sui-CardSubscription-buttonIcon"
            })
          })]
        }), checkboxName && /*#__PURE__*/_jsx("div", {
          className: "sui-CardSubscription-formCheck",
          children: /*#__PURE__*/_jsx(FormCheckbox, {
            name: checkboxName,
            checked: termsOfUseAccepted,
            onChange: _this._handleCheckboxChange,
            label: checkboxLabel,
            errorMessage: _this._getCheckboxError(),
            svgIcons: checkboxIcons
          })
        })]
      });
    };

    return _this;
  }

  var _proto = CardSubscription.prototype;

  _proto.render = function render() {
    var _this$props2 = this.props,
        ResponseContent = _this$props2.responseContent,
        responseError = _this$props2.responseError,
        title = _this$props2.title;
    var termsOfUseAccepted = this.state.termsOfUseAccepted;
    return /*#__PURE__*/_jsxs("div", {
      children: [(!ResponseContent || !!responseError) && /*#__PURE__*/_jsx("div", {
        className: "sui-CardSubscription",
        children: /*#__PURE__*/_jsxs("div", {
          className: "sui-CardSubscription-content",
          children: [/*#__PURE__*/_jsx("p", {
            className: "sui-CardSubscription-title",
            children: title
          }), this._printCardContent({
            termsOfUseAccepted: termsOfUseAccepted
          }), ResponseContent && responseError && /*#__PURE__*/_jsx(ResponseContent, {})]
        })
      }), ResponseContent && !responseError && /*#__PURE__*/_jsx(ResponseContent, {})]
    });
  };

  return CardSubscription;
}(Component);

export { CardSubscription as default };
CardSubscription.displayName = 'CardSubscription';